local HealingTracker = _G.HealingTracker

local classColors = {
	["None"] = { R = 1, G = 1, B = 1 },
	["Warrior"] = { R = 0.78, G = 0.61, B = 0.43 },
	["Paladin"] = { R = 0.96, G = 0.55, B = 0.73 },
	["Hunter"] = { R = 0.67, G = 0.83, B = 0.45 },
	["Rogue"] = { R = 1, G = 0.96, B = 0.41 },
	["Priest"] = { R = 1, G = 1, B = 1 },
	["Death Knight"] = { R = 0.77, G = 0.12, B = 0.23 },
	["Demon Hunter"] = { R = 0.64, G = 0.19, B = 0.79 },
	["Shaman"] = { R = 0.14, G = 0.35, B = 1 },
	["Mage"] = { R = 0.41, G = 0.80, B = 0.94 },
	["Warlock"] = { R = 0.58, G = 0.51, B = 0.79 },
	["Monk"] = { R = 0.04, G = 0.59, B = 0.45 },
	["Druid"] = { R = 1, G = 0.49, B = 0.04 },
}

local classTextures = {
	["None"] = "shaman",
    ["Warrior"] = "warrior",
	["Paladin"] = "paladin",
	["Hunter"] = "hunter",
	["Rogue"] = "rogue",
	["Priest"] = "priest",
	["Death Knight"] = "deathknight",
	["Demon Hunter"] = "demonhunter",
	["Shaman"] = "shaman",
	["Mage"] = "mage",
	["Warlock"] = "warlock",
	["Monk"] = "monk",
	["Druid"] = "druid",
}

local instances = {

    -- SHADOWLANDS

    [13224] = {
        Id = 13224,
        Name = "Castle Nathria",
        Abbreviation = "Nathria",
        Bosses = {
            ["Shriekwing"] = "Shriekwing",
            ["Huntsman Altimor"] = "Huntsman Altimor",
            ["Kael'thas Sunstrider"] = "Kael'thas Sunstrider",
            ["Artificer Xy'mox"] = "Artificer Xy'mox",
            ["Hungering Destroyer"] = "Hungering Destroyer",
            ["Lady Inerva Darkvein"] = "Lady Inerva Darkvein",
            ["Garothi Worldbreaker"] = "Garothi Worldbreaker",
            ["The Council of Blood"] = "The Council of Blood",
            ["Castellan Niklaus"] = "The Council of Blood",
            ["Sludgefist"] = "Sludgefist",
            ["Stone Legion Generals"] = "Stone Legion Generals",
            ["General Kaal"] = "Stone Legion Generals",
            ["Sire Denathrius"] = "Sire Denathrius"
        }
    },

    [12916] = {
        Id = 12916,
        Name = "The Necrotic Wake",
        Abbreviation = "NW",
        Bosses = {
            ["Blightbone"] = "Blightbone",
            ["Surgeon Stitchflesh"] = "Surgeon Stitchflesh",
            ["Nalthor the Rimebinder"] = "Il'Nalthor the Rimebinder"
        }
    },

    [13228] = {
        Id = 13228,
        Name = "Plaguefall",
        Abbreviation = "PF",
        Bosses = {
            ["Globgrog"] = "Globgrog",
            ["Doctor Ickus"] = "Doctor Ickus",
            ["Domina Venomblade"] = "Domina Venomblade",
            ["Margrave Stradama"] = "Margrave Stradama"
        }
    },

    [13334] = {
        Id = 13334,
        Name = "Mists of Tirna Scithe",
        Abbreviation = "MoTS",
        Bosses = {
            ["Ingra Maloch"] = "Ingra Maloch",
            ["Mistcaller"] = "Mistcaller",
            ["Tred'ova"] = "Tred'ova"
        }
    },

    [12831] = {
        Id = 12831,
        Name = "Halls of Atonement",
        Abbreviation = "HoA",
        Bosses = {
            ["Ingra Maloch"] = "Ingra Maloch",
            ["Halkias"] = "Halkias",
            ["Echelon"] = "Echelon",
            ["High Adjudicator Aleez"] = "High Adjudicator Aleez",
            ["Lord Chamberlain"] = "Lord Chamberlain"
        }
    },

    [13309] = {
        Id = 13309,
        Name = "De Other Side",
        Abbreviation = "DOS",
        Bosses = {
            ["Hakkar the Soulflayer"] = "Hakkar the Soulflayer",
            ["The Manastorms"] = "The Manastorms",
            ["Dealer Xy'exa"] = "Dealer Xy'exa",
            ["Mueh'zala"] = "Mueh'zala"
        }
    },

    [12842] = {
        Id = 12842,
        Name = "Sanguine Depths",
        Abbreviation = "SD",
        Bosses = {
            ["Kryxis the Voracious"] = "Kryxis the Voracious",
            ["Executor Tarvold"] = "Executor Tarvold",
            ["Grand Proctor Beryllia"] = "Grand Proctor Beryllia",
            ["General Kaal"] = "General Kaal"
        }
    },

    [12837] = {
        Id = 12837,
        Name = "Spires of Ascension",
        Abbreviation = "SoA",
        Bosses = {
            ["Kin-Tara"] = "Kin-Tara",
            ["Ventunax"] = "Ventunax",
            ["Oryphrion"] = "Oryphrion",
            ["Devos"] = "Devos"
        }
    },

    [12841] = {
        Id = 12841,
        Name = "Theater of Pain",
        Abbreviation = "ToP",
        Bosses = {
            ["Dessia the Decapitator"] = "Dessia the Decapitator",
            ["Gorechop"] = "Gorechop",
            ["Xav the Unfallen"] = "Xav the Unfallen",
            ["Kul'tharok"] = "Kul'tharok",
            ["Mordretha"] = "Mordretha"
        }
    },

    -- BFA

    [9028] = {
        Id = 9028,
        Name = "Atal'Dazar",
        Abbreviation = "AD",
        Bosses = {
            ["Priestess Alun'za"] = "Priestess Alun'za",
            ["Vol'kaal"] = "Vol'kaal",
            ["Rezan"] = "Rezan",
            ["Yazma"] = "Yazma"
        }
    },

    [9164] = {
        Id = 9164,
        Name = "Freehold",
        Abbreviation = "FH",
        Bosses = {
            ["Skycap'n Kragg"] = "Skycap'n Kragg",
            ["Captain Eudora"] = "Council o' Captains",
            ["Shark Puncher"] = "Ring of Booty",
            ["Harlan Sweete"] = "Harlan Sweete"
        }
    },

    [9391] = {
        Id = 9391,
        Name = "The Underrot",
        Abbreviation = "UR",
        Bosses = {
            ["Elder Leaxa"] = "Elder Leaxa",
            ["Cragmaw the Infested"] = "Cragmaw the Infested",
            ["Sporecaller Zancha"] = "Sporecaller Zancha",
            ["Unbound Abomination"] = "Unbound Abomination"
        }
    },

    [9424] = {
        Id = 9424,
        Name = "Waycrest Manor",
        Abbreviation = "WM",
        Bosses = {
            ["Sister Briar"] = "Heartsbane Triad",
            ["Heartsbane Triad"] = "Heartsbane Triad",
            ["Soulbound Goliath"] = "Soulbound Goliath",
            ["Raal the Gluttonous"] = "Raal the Gluttonous",
            ["Lord Waycrest"] = "Lord and Lady Waycrest",
            ["Gorak Tul"] = "Gorak Tul"
        }
    },

    [8064] = {
        Id = 8064,
        Name = "The MOTHERLODE!!",
        Abbreviation = "ML",
        Bosses = {
            ["Coin-Operated Crowd Pummeler"] = "Coin-Operated Crowd Pummeler",
            ["Azerokk"] = "Azerokk",
            ["Rixxa Fluxflame"] = "Rixxa Fluxflame",
            ["Mogul Razdunk"] = "Mogul Razdunk"
        }
    },

    [9525] = {
        Id = 9525,
        Name = "Shrine of the Storm",
        Abbreviation = "SoTS",
        Bosses = {
            ["Aqu'sirr"] = "Aqu'sirr",
            ["Brother Ironhull"] = "Tidesage Council",
            ["Lord Stormsong"] = "Lord Stormsong",
            ["Vol'zith the Whisperer"] = "Vol'zith the Whisperer"
        }
    },

    [9527] = {
        Id = 9527,
        Name = "Temple of Sethraliss",
        Abbreviation = "ToS",
        Bosses = {
            ["Adderis"] = "Adderis and Aspix",
            ["Aspix"] = "Adderis and Aspix",
            ["Merektha"] = "Merektha",
            ["Galvazzt"] = "Galvazzt",
            ["Avatar of Sethraliss"] = "Avatar of Sethraliss"
        }
    },

    [9526] = {
        Id = 9526,
        Name = "Kings' Rest",
        Abbreviation = "KR",
        Bosses = {
            ["The Golden Serpent"] = "The Golden Serpent",
            ["Mchimba the Embalmer"] = "Mchimba the Embalmer",
            ["Aka'ali the Conqueror"] = "The Council of Tribes",
            ["King Dazar"] = "King Dazar"
        }
    },

    [9354] = {
        Id = 9354,
        Name = "Siege of Boralus",
        Abbreviation = "SoB",
        Bosses = {
            ["Chopper Redhook"] = "Chopper Redhook",
            ["Sergeant Bainbridge"] = "Sergeant Bainbridge",
            ["Dread Captain Lockwood"] = "Dread Captain Lockwood",
            ["Hadal Darkfathom"] = "Hadal Darkfathom",
            ["Viq'Goth"] = "Viq'Goth"
        }
    },

    [10225] = {
        Id = 10225,
        Name = "Operation: Mechagon",
        Abbreviation = "OM",
        Bosses = {
            ["King Gobbamak"] = "King Gobbamak",
            ["Gunker"] = "Gunker",
            ["Trixie Tazer"] = "Trixie & Naeno",
            ["HK-8 Aerial Oppression Unit"] = "HK-8 Aerial Oppression Unit",
            ["The Platinum Pummeler"] = "Tussle Tonks",
            ["K.U.-J.0."] = "K.U.-J.0.",
            ["Head Machinist Sparkflux"] = "Machinist's Garden",
            ["King Mechagon"] = "King Mechagon"
        }
    },

    [9327] = {
        Id = 9327,
        Name = "Tol Dagor",
        Abbreviation = "TD",
        Bosses = {
            ["The Sand Queen"] = "The Sand Queen",
            ["Jes Howlis"] = "Jes Howlis",
            ["Knight Captain Valyri"] = "Knight Captain Valyri",
            ["Overseer Korgus"] = "Overseer Korgus"
        }
    }

}

local innervate = 29166
local targetSpells = {116849, 6940, 633, 1022, 204018, 47788, 73325, 33206, 102342}
local nontargetSpells = {740, 108280, 108281, 114052, 98008, 16191, 79206, 207399, 192077, 31821, 204150, 31842, 115310, 198664, 62618, 64843, 64901, 97462, 15286, 196718}

local emergencyTable = { 1, 3, 5, 7, 9, 11, 13, 15, 17, 19, 20, 21, 22, 23, 24, 25, 26, 26, 27, 27, 28, 28, 29, 29, 30, 30, 30, 31, 31, 31, 32, 32, 32, 33, 33, 33, 33, 34, 34, 34, 34, 34, 35, 35, 35, 35, 35, 35, 36, 36}
local regularTable = { 1, 1, 2, 2, 3, 4, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 10, 11, 11, 12, 12, 13, 13, 13, 14, 14, 14, 15, 15, 15, 15, 16, 16, 16, 16, 17, 17, 17, 17, 18, 18, 18, 18, 19, 19, 19, 19, 19, 20, 20}

_G["ClassColors"] = classColors
_G["ClassTextures"] = classTextures
_G["Instances"] = instances
_G["EmergencyTable"] = emergencyTable
_G["RegularTable"] = regularTable

HealingTracker.Constants.ClassColors = classColors
HealingTracker.Constants.ClassTextures = classTextures
HealingTracker.Constants.Instances = instances
HealingTracker.Constants.EmergencyTable = emergencyTable
HealingTracker.Constants.RegularTable = regularTable
HealingTracker.Constants.TargetSpells = targetSpells
HealingTracker.Constants.NonTargetSpells = nontargetSpells
HealingTracker.Constants.Innervate = innervate

local Helper = HealingTracker.Helper

function Helper:PSHTableSort(item1, item2)
	return item1.AidfulHeal < item2.AidfulHeal
end

function Helper:PSPTableSort(item1, item2)
	return (item1.PointMultiply + item1.PointRegular) < (item2.PointMultiply + item2.PointRegular)
end

function Helper:TotalHealTableSort(item1, item2)
	return (item1.AidfulHeal + item1.PointlessHeal + item1.AidfulPeriodicHeal + item1.PointlessPeriodicHeal) < (item2.AidfulHeal + item2.PointlessHeal + item2.AidfulPeriodicHeal + item2.PointlessPeriodicHeal)
end

function Helper:AidfulHealTableSort(item1, item2)
	return (item1.AidfulHeal + item1.AidfulPeriodicHeal) < (item2.AidfulHeal + item2.AidfulPeriodicHeal)
end

function Helper:PointlessHealTableSort(item1, item2)
	return (item1.PointlessHeal + item1.PointlessPeriodicHeal) < (item2.PointlessHeal + item2.PointlessPeriodicHeal)
end

function Helper:TrackPointTableSort(item1, item2)
	return (item1.TotalMultiply + item1.TotalRegular) < (item2.TotalMultiply + item2.TotalRegular)
end

function Helper:ActiveHealTableSort(item1, item2)
    if item1.ActiveHeal and item2.ActiveHeal then
        return item1.ActiveHeal < item2.ActiveHeal
    elseif item1.ActiveHeal then
        return 0
    else
        return 1
    end
end

function Helper:GTTableSort(item1, item2)
	return (item1.TotalMultiply + item1.TotalRegular) < (item2.TotalMultiply + item2.TotalRegular)
end

function Helper:SpellTotalHealTableSort(item1, item2)
	return (item1.AidfulHeal + item1.PointlessHeal + item1.AidfulPeriodicHeal + item1.PointlessPeriodicHeal) < (item2.AidfulHeal + item2.PointlessHeal + item2.AidfulPeriodicHeal + item2.PointlessPeriodicHeal)
end

function Helper:SpellAidfulHealTableSort(item1, item2)
	return (item1.AidfulHeal + item1.AidfulPeriodicHeal) < (item2.AidfulHeal + item2.AidfulPeriodicHeal)
end

function Helper:SpellPointlessHealTableSort(item1, item2)
	return (item1.PointlessHeal + item1.PointlessPeriodicHeal) < (item2.PointlessHeal + item2.PointlessPeriodicHeal)
end

function Helper:SpellTrackPointTableSort(item1, item2)
	return (item1.PointMultiply + item1.PointRegular) < (item2.PointMultiply + item2.PointRegular)
end

function Helper:GUP(c)
	local f = UnitHealthMax(c)
	local n = UnitHealth(c)
	local r = n * 100 / f
	return math.floor(r)
end

function Helper:ReadableNumber(v)
    if v == nil then return "0" end
	if v <= 999 then
		return format("%.0f", v)
	elseif v >= 1000000000 then
		return format("%.2fB", v/1000000000)
	elseif v >= 1000000 then
		return format("%.2fM", v/1000000)
	elseif v >= 1000 then
		return format("%.1fK", v/1000)
    end
    return "0"
end

function Helper:SortSpells(player, sorter)
    local slogs = player.Spells
    for c=0,#slogs,1 do
        for i=#slogs,2,-1 do
            local cur = slogs[i]
            local prev = slogs[i - 1]
                
            if cur ~= nil and prev ~= nil then
                local cv = false
                if sorter == 1 then -- point
                    cv = Helper:SpellTrackPointTableSort(prev, cur)
                elseif sorter == 2 then -- total heal
                    cv = Helper:SpellTotalHealTableSort(prev, cur)
                elseif sorter == 3 then -- aidful heal
                    cv = Helper:SpellAidfulHealTableSort(prev, cur)
                elseif sorter == 4 then -- pointless heal
                    cv = Helper:SpellPointlessHealTableSort(prev, cur)
                else
                    cv = Helper:SpellTrackPointTableSort(prev, cur)
                end
                if cv == true then
                    slogs[i] = prev
                    slogs[i - 1] = cur
                end
                else
                    break
                end
            end
        end
    return slogs
end

function Helper:GetTimeSpan(seconds)

    local mins = 0
    local secs = seconds
    while secs > 59 do
        secs = secs - 60
        mins = mins + 1
    end

    local secs_str = tostring(secs)
    local mins_str = tostring(mins)

    if string.len(secs_str) < 2 then
        secs_str = "0"..secs_str
    end
    
    if string.len(mins_str) < 2 then
        mins_str = "0"..mins_str
    end
    
    return mins_str..":"..secs_str

end